import 'package:flutter/material.dart';

class FilterListParams{
  final String _searchFieldLabel;
  final Function( String ) _functionFilter;

  FilterListParams(
    this._searchFieldLabel,
    this._functionFilter
  );
}

class FilterList extends SearchDelegate<String> {
  final FilterListParams _params;

  FilterList( this._params ): super( searchFieldLabel: _params._searchFieldLabel ?? "Buscar" );

  @override
  List<Widget> buildActions( BuildContext context ) {
    //Actions for app bar
    return [
      IconButton(
        icon: Icon( Icons.clear ),
        onPressed: () {
          query = "";
        }
      )
    ];
  }

  @override
  Widget buildLeading( BuildContext context ) {
    //leading icon on the left of the app bar
    return IconButton(
      icon: AnimatedIcon(
        icon: AnimatedIcons.menu_arrow,
        progress: transitionAnimation,
      ),
      onPressed: () {
        close( context, null );
      }
    );
  }

  @override
  Widget buildResults( BuildContext context ) {
    // show some result based on the selection
    return Center(
      child: Text( query )
    );
  }

  @override
  Widget buildSuggestions( BuildContext context ) {

    // Realiza o filtro
    return this._params?._functionFilter( query )
      ?? Center(
        child: Text( "Nenhuma método informado para realizar o filtro" )
      );
  }
}