library snack_bar;
import 'package:flutter/material.dart';

class SnackBarActionParam{
  final String label;
  final Function onClickAction;

  SnackBarActionParam( this.label, this.onClickAction );
}

class SnackBarParam{
  final String content;
  final SnackBarActionParam action;
  int durationSeconds;
  Color backgroundColor;

  SnackBarParam(
    this.content,
    {
      this.durationSeconds = 5,
      this.backgroundColor = Colors.black,
      this.action
    }
  );
}

class ShowSnackBar{

  static void show( BuildContext context, SnackBarParam _parameter ){

    if( null != _parameter ){

      Scaffold.of( context ).showSnackBar(
        SnackBar(
          content: Text( _parameter.content ),
          action: null != _parameter.action
          ? SnackBarAction(
            label: _parameter.action.label,
            //onPressed: () => print( "clicou" )
            onPressed: () => _parameter.action.onClickAction( ),
          )
          : null,
          duration: Duration( seconds: _parameter.durationSeconds ),
          backgroundColor: _parameter.backgroundColor
        ),
      );
    }
  }
}